unit uMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    cX86: TCheckBox;
    cX64: TCheckBox;
    tX86: TEdit;
    tX64: TEdit;
    bCreate: TButton;
    Label1: TLabel;
    tName: TEdit;
    cInject: TCheckBox;
    procedure bCreateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Type
  tPlugin = packed record
    sMagic      : array [0..5] of Byte;
    sName       : array [0..19] of Byte;
    dwX64Offset : DWORD;
    bAllProc    : Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Function ReadFromFile(sFile : pChar; pLen : PDWORD):Pointer;stdcall;
var
  hFile  : tHandle;
  dwTemp : DWORD;
begin
  //Get Pointer

  //Assume Failure
  Result := nil;

  //Create File
  hFile  := CreateFileW(sFile, $80000000, $00000001, $00000000, $00000003, $00000000, $00000000);

  //Check Handle
  if (hFile <> -1) and (pLen <> nil) then
    begin
      //Get Length
      pLen^ := GetFileSize(hFile, @dwTemp);

      //Check Length
      if (pLen^ <> $FFFFFFFF) and (pLen^ > $00000000) then
        begin
          //Allocate Memory For The File
          Result := VirtualAllocEx(tHandle(-1), nil, pLen^, $1000 or $2000, $40);

          //Read File To Memory
          if (Result <> nil) then ReadFile(hFile, pByte(Result)^, pLen^, dwTemp, nil);
        end;

      //Close Handle
      CloseHandle(hFile);
    end;
end;

Function WriteToFile(sFile : Pointer; pContent : Pointer; dwLen : DWORD):BOOLEAN;stdcall;
var
  hFile  : tHandle;
  dwTemp : DWORD;
begin
  //Assume Failure
  Result := False;

  //Unicode^^
  hFile := CreateFileW(sFile, $40000000, $00000002, $00000000, $00000002, $00000000, $00000000);

  //Check file handle
  if (hFile <> -1) then
    begin
      //Yeah! File opened, let's write to it.
      Result := WriteFile(hFile, pByte(pContent)^, dwLen, dwTemp, nil);

      //Close Handle
      CloseHandle(hFile);
    end;
end;

Procedure ZeroMem(pPointer : Pointer; dwLen : DWORD);stdcall;
//Zeroes Pointer -> Pointer+dwLen
var
  i : DWORD;
begin
  for i := 0 to (dwLen -1) do
    begin
      pByte(tHandle(pPointer) + i)^ := $00;
    end;
end;

procedure TForm1.bCreateClick(Sender: TObject);
var
  tStruct : tPlugin;
  pX86    : Pointer;
  pX64    : Pointer;
  dwX86Len: DWORD;
  dwX64Len: DWORD;
  pPlugin : Pointer;
begin
  //Initialize
  pX86     := nil;
  pX64     := nil;
  pPlugin  := nil;
  dwX86Len := 0;
  dwX64Len := 0;

  //Zero Struct
  ZeroMem(@tStruct, SizeOf(tStruct));

  //Fill in the header
  CopyMemory(@tStruct.sMagic[0], pAnsiChar(AnsiString('SOLAR')), 5);

  //Fill in the name
  CopyMemory(@tStruct.sName[0], pAnsiChar(AnsiString(tName.Text)), Length(tName.Text));

  //Check if we need to load x86 part
  if (cX86.Checked = True) then
    begin
      //Read the DLL
      pX86 := ReadFromFile(pChar(tX86.Text), @dwX86Len);
    end;

  //Check if we need to load x64 part
  if (cX64.Checked = True) then
    begin
      //Read the DLL
      pX64 := ReadFromFile(pChar(tX64.Text), @dwX64Len);

      //Set offset
      tStruct.dwX64Offset := dwX86len;
    end;

  //Fill in inject option
  if (cInject.Checked = True) then tStruct.bAllProc := True;

  //Check if there is anything
  if (pX86 <> nil) or (pX64 <> nil) then
    begin
      //Allocate Memory For Plugin
      pPlugin := VirtualAllocEx(tHandle(-1), nil, dwX86Len + dwX64Len + SizeOf(tStruct), $1000 or $2000, $40);

      //Always check pointers
      if (pPlugin <> nil) then
        begin
          //Write struct
          CopyMemory(pPlugin, @tStruct, SizeOf(tStruct));

          //Write x86 dll
          if (dwX86Len > 0) then CopyMemory(Pointer(tHandle(pPlugin) + SizeOf(tStruct)), pX86, dwX86Len);

          //Write x64 dll
          if (dwX64Len > 0) then CopyMemory(Pointer(tHandle(pPlugin) + SizeOf(tStruct) + dwX86Len), pX64, dwX64Len);

          //Write To File
          WriteToFile(pChar('Plugin.bin'), pPlugin, dwX86Len + dwX64Len + SizeOf(tStruct));
        end;
    end;
end;

end.
